package com.steerinfo.baseinfo.meterbasebeltmaterialpm.controller;

import com.steerinfo.baseinfo.meterbasebeltmaterialpm.model.MeterBaseBeltMaterialPm;
import com.steerinfo.baseinfo.meterbasebeltmaterialpm.service.IMeterBaseBeltMaterialPmService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkbelttiminginfo.model.MeterWorkBeltTiminginfo;
import com.steerinfo.pretrack.prebeltscale.model.PreBeltScale;
import com.steerinfo.util.CommonPage;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseBeltMaterialPm RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-11-01 02:04
 * 类描述
 * 修订历史：
 * 日期：2021-11-01
 * 作者：generator
 * 参考：
 * 描述：MeterBaseBeltMaterialPm RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbasebeltmaterialpms")
public class MeterBaseBeltMaterialPmController extends BaseRESTfulController {

    @Autowired
    IMeterBaseBeltMaterialPmService meterBaseBeltMaterialPmService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasebeltmaterialpm:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseBeltMaterialPm> list = meterBaseBeltMaterialPmService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasebeltmaterialpm:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseBeltMaterialPm> list = meterBaseBeltMaterialPmService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterBaseBeltMaterialPm对象创建")
    @ApiImplicitParam(name = "meterBaseBeltMaterialPm", value = "详细实体meterBaseBeltMaterialPm", required = true, dataType = "MeterBaseBeltMaterialPm")
    //@RequiresPermissions("meterbasebeltmaterialpm:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterBaseBeltMaterialPm model){
        MeterBaseBeltMaterialPm meterBaseBeltMaterialPm = meterBaseBeltMaterialPmService.add(model);
        return success(meterBaseBeltMaterialPm);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasebeltmaterialpm:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseBeltMaterialPm meterBaseBeltMaterialPm = meterBaseBeltMaterialPmService.getById(id);
        return success(meterBaseBeltMaterialPm);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseBeltMaterialPm信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseBeltMaterialPm", value = "详细实体meterBaseBeltMaterialPm", required = true, dataType = "MeterBaseBeltMaterialPm")
    })
    //@RequiresPermissions("meterbasebeltmaterialpm:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseBeltMaterialPm model){
        model.setId(id);
        MeterBaseBeltMaterialPm meterBaseBeltMaterialPm = meterBaseBeltMaterialPmService.modify(model);
        return success(meterBaseBeltMaterialPm);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasebeltmaterialpm:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseBeltMaterialPmService.delete(ids);
    	}
      return success();
    }

    @Transactional(rollbackFor = Exception.class)
    @ApiOperation(value = "C#端皮带秤", notes = "根据MeterBaseBeltMaterialPm对象创建")
    @ApiImplicitParam(name = "MeterBaseBeltMaterialPm", value = "详细实体MeterBaseBeltMaterialPm", required = true, dataType = "MeterBaseBeltMaterialPm")
    @PostMapping(value = "/doAddMaterialPm")
    public RESTfulResult doAddMaterialPm(@RequestBody MeterBaseBeltMaterialPm model) {
        RESTfulResult rm = failed();
        try {
            model.setCreateTime(new Date());
            int  str= meterBaseBeltMaterialPmService.doAddMaterialPm(model);
            if (str>0) {
                return success(str);
            } else {
                return failed("操作失败!" + str);
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
            rm.setData(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！"+e.getMessage());
            rm.setData("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @Transactional(rollbackFor = Exception.class)
    @ApiOperation(value = "C#端皮带秤", notes = "根据MeterBaseBeltMaterialPm对象创建")
    @ApiImplicitParam(name = "MeterBaseBeltMaterialPm", value = "详细实体Me terBaseBeltMaterialPm", required = true, dataType = "MeterBaseBeltMaterialPm")
    //@RequiresPermissions("meterworkstorageactual:create")
    @PostMapping(value = "/updateMaterialPm")
    public RESTfulResult updateMaterialPm(@RequestBody MeterBaseBeltMaterialPm model) {
        RESTfulResult rm = failed();
        try {
            model.setUpdateTime(new Date());
            int  str= meterBaseBeltMaterialPmService.updateMaterialPm(model);
            if (str>0) {
                return success(str);
            } else {
                return failed("操作失败!" + str);
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
            rm.setData(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！"+e.getMessage());
            rm.setData("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @Transactional(rollbackFor = Exception.class)
    @ApiOperation(value = "C#端皮带秤", notes = "根据MeterBaseBeltMaterialPm对象创建")
    @ApiImplicitParam(name = "MeterBaseBeltMaterialPm", value = "详细实体Me terBaseBeltMaterialPm", required = true, dataType = "MeterBaseBeltMaterialPm")
    //@RequiresPermissions("meterworkstorageactual:create")
    @PostMapping(value = "/doUpdateFlags")
    public RESTfulResult doUpdateFlags(@RequestBody List<MeterBaseBeltMaterialPm> models) {
        RESTfulResult rm = failed();
        int num= 0;
        try {
            if("0".equals(models.get(0).getValidFlag())){
                num = meterBaseBeltMaterialPmService.doUpdateFlags_0(models);
            }else if("1".equals(models.get(0).getValidFlag())){
                num = meterBaseBeltMaterialPmService.doUpdateFlags_1(models);
            }
            if(num>=1){
                return success(num);
            }else{
                return failed("修改物料系数状态失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }
    @ApiOperation(value = "C#端入库秤实绩", notes = "根据MeterBaseBeltMaterialPm对象创建")
    @ApiImplicitParam(name = "MeterBaseBeltMaterialPm", value = "详细实体MeterBaseBeltMaterialPm", required = true, dataType = "MeterBaseBeltMaterialPm")
    @PostMapping(value = "/doQueryByBeltType")
    public RESTfulResult doQueryByBeltType(@RequestBody CommonPage<PreBeltScale> model) {
        try {
            List<MeterBaseBeltMaterialPm> no = meterBaseBeltMaterialPmService.doQueryByBeltType(model);
            return success(no);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }
}
